#include <clutter/clutter.h>
#include <stdlib.h>
#include <time.h>

#define MAX_MUSHROOMS 5
#define MAX_WAGNERS 2

ClutterActor * stage, *background, * rect, * rectTwo, * score, * gameOver, * youWin, * mainOk, * mainOkBg, * mainOkButton, * restartGroup, * restartBg, * restartButton, * mushroom[MAX_MUSHROOMS], * wagner[MAX_WAGNERS], * cage;
gint mushrooms_collected, game_over;

void move_wagners(gfloat cageX, gfloat cageY)
{
	gfloat wagX, wagY;
	
	int i;
	for(i=0;i<MAX_WAGNERS;i++)
	{
		clutter_actor_get_position(wagner[i], &wagX, &wagY);
		if(rand()%3>0)
		{
		if(rand()%2==0)
		{
			if(wagX<cageX) wagX += 64;
			if(wagX>cageX) wagX -= 64;
		} else {
			if(wagY<cageY) wagY += 64;
			if(wagY>cageY) wagY -= 64;
		}
		}
		clutter_actor_set_position(wagner[i], wagX, wagY);
		if(wagX==cageX && wagY==cageY)
		{
			// LOSE
			game_over = 3;
			clutter_actor_animate(gameOver, CLUTTER_EASE_IN_QUAD, 250, "opacity", 0xff, NULL);
			clutter_actor_animate(restartGroup, CLUTTER_EASE_IN_QUAD, 250, "opacity", 0xff, NULL);
		}
	}
}

void on_key_press (ClutterActor * actor, ClutterEvent *event, gpointer user_data)
{
	if(game_over==0)
	{
		gfloat cageX, cageY, mushX, mushY;
		
		clutter_actor_get_position(cage, &cageX, &cageY);
		
		guint keyval = clutter_event_get_key_symbol (event);	
		
		if(keyval == CLUTTER_KEY_Left && cageX>0)
		{
			cageX -= 64;
			if(cageX < 0) cageX += 640;
			move_wagners(cageX, cageY);	
		}
		if(keyval == CLUTTER_KEY_Right && cageX+64<640)
		{
			cageX += 64;
			if(cageX > 640) cageX -= 640;
			move_wagners(cageX, cageY);	
		}
		if(keyval == CLUTTER_KEY_Up && cageY>0)
		{
			cageY -= 64;
			if(cageY < 0) cageY += 512;
			move_wagners(cageX, cageY);	
		}
		if(keyval == CLUTTER_KEY_Down && cageY+64<512)
		{
			cageY += 64;
			if(cageY > 512) cageY -= 512;
			move_wagners(cageX, cageY);	
		}
		int i;
		for(i=0;i<MAX_MUSHROOMS;i++)
		{
			clutter_actor_get_position(mushroom[i], &mushX, &mushY);
			if(cageX==mushX && cageY==mushY)
			{
				clutter_actor_set_position(mushroom[i], 640, 512);
				mushrooms_collected++;
				char text[64];
				sprintf(text, "MUSHROOMS: %d/%d", mushrooms_collected, MAX_MUSHROOMS);
				clutter_text_set_text(CLUTTER_TEXT(score), text);
			}
		}
		clutter_actor_set_position(cage, cageX, cageY);
		if(mushrooms_collected==5 && game_over==0)
		{
			// WIN
			game_over = 2;
			clutter_actor_animate(youWin, CLUTTER_EASE_IN_QUAD, 250, "opacity", 0xff, NULL);
			clutter_actor_animate(restartGroup, CLUTTER_EASE_IN_QUAD, 250, "opacity", 0xff, NULL);
		}
	}
}

void on_restartGroup_click (ClutterActor * actor, ClutterEvent * event, gpointer user_data)
{
	if(game_over>1)
	{
		// RESTART
		clutter_actor_animate(youWin, CLUTTER_EASE_IN_QUAD, 250, "opacity", 0x00, NULL);
		clutter_actor_animate(gameOver, CLUTTER_EASE_IN_QUAD, 250, "opacity", 0x00, NULL);
		clutter_actor_animate(restartGroup, CLUTTER_EASE_IN_QUAD, 250, "opacity", 0x00, NULL);

		clutter_actor_set_position (cage, 9*64, 7*64);		

		game_over=0;
		mushrooms_collected = 0;
	
		int i;
		
		for(i=0;i<MAX_MUSHROOMS;i++)
		{
			clutter_actor_set_position (mushroom[i], (rand()%9)*64, (rand()%7)*64);		
		}

		for(i=0;i<MAX_WAGNERS;i++)
		{
			clutter_actor_set_position (wagner[i], (rand()%8)*64, (rand()%6)*64);		
		}
		
		char text[64];
		sprintf(text, "MUSHROOMS: %d/%d", mushrooms_collected, MAX_MUSHROOMS);
		clutter_text_set_text(CLUTTER_TEXT(score), text);
	}
}

void on_mainOk_click (ClutterActor * actor, ClutterEvent * event, gpointer user_data)
{
	if(game_over==1)
	{
		clutter_actor_animate(rect, CLUTTER_EASE_IN_QUAD, 250, "opacity", 0x00, NULL);
		clutter_actor_animate(rectTwo, CLUTTER_EASE_IN_QUAD, 250, "opacity", 0x00, NULL);
		clutter_actor_animate(mainOk, CLUTTER_EASE_IN_QUAD, 250, "opacity", 0x00, NULL);
			
		int i;
		for(i=0;i<MAX_MUSHROOMS;i++)
		{
			clutter_actor_animate(mushroom[i], CLUTTER_EASE_IN_QUAD, 250, "opacity", 0xff, NULL);
		}
		for(i=0;i<MAX_WAGNERS;i++)
		{
			clutter_actor_animate(wagner[i], CLUTTER_EASE_IN_QUAD, 250, "opacity", 0xff, NULL);
		}	
		clutter_actor_animate(score, CLUTTER_EASE_IN_QUAD, 250, "opacity", 0xff, NULL);
	
		game_over = 0;
	}
}

int main ( int argc, char **argv)
{
	srand(time(NULL));
	
	ClutterColor red = { 0xd3, 0x2e, 0x32, 0xff };
	ClutterColor orange = { 0xff, 0x50, 0x04, 0xff };
	ClutterColor cream = { 0xed, 0xb9, 0x49, 0xff };
	ClutterColor white = { 0xfb, 0xeb, 0xca, 0xff };
	ClutterColor green = { 0x31, 0xb6, 0x7d, 0xff };

	mushrooms_collected = 0;
	game_over = 1;
	
	clutter_init (&argc, &argv);

	stage = clutter_stage_get_default ();

	clutter_actor_set_size (stage, 640, 512);
	
	clutter_stage_set_color (CLUTTER_STAGE (stage), &green);

	background = clutter_texture_new_from_file("bg.png", NULL);
	clutter_actor_set_size (background, 640, 512);
	clutter_container_add_actor (CLUTTER_CONTAINER (stage), background);
	clutter_actor_set_position (background, 0, 0);
	clutter_actor_show (background);

	rect = clutter_text_new_full("Serif 30", "CAGE IN THE FOREST WITH MUSHROOMS", &white);
	clutter_actor_set_size(rect, 320, 240);
	clutter_actor_set_position(rect, 160, 120);
	clutter_container_add_actor(CLUTTER_CONTAINER(stage), rect);
	rectTwo = clutter_text_new_full("Serif 12", "(use the arrow keys to move John as he collects wild mushrooms. Avoid Wagner or you die.)", &white);
	clutter_actor_set_size(rectTwo, 320, 240);
	clutter_actor_set_position(rectTwo, 160, 270);
	clutter_container_add_actor(CLUTTER_CONTAINER(stage), rectTwo);
	clutter_actor_show(rectTwo);
	
	mainOk = clutter_group_new();
	clutter_actor_set_position(mainOk, 285, 345);
	clutter_actor_set_size(mainOk, 70, 30);
	clutter_container_add_actor(CLUTTER_CONTAINER(stage), mainOk);
	clutter_actor_set_reactive (mainOk, TRUE);
	
	mainOkBg = clutter_rectangle_new_with_color(&orange);
	clutter_container_add_actor(CLUTTER_CONTAINER(mainOk), mainOkBg);
	clutter_actor_set_size(mainOkBg, 70, 30);
        clutter_actor_set_position(mainOkBg, 0, 0);

	mainOkButton = clutter_text_new_full("Sans 12", "PLAY!", &cream);
	clutter_container_add_actor(CLUTTER_CONTAINER(mainOk), mainOkButton);
	clutter_actor_set_size(mainOkButton, 70, 30);
        clutter_actor_set_position(mainOkButton, 10, 5);

	clutter_actor_show(mainOk);
       
	cage = clutter_texture_new_from_file("cage.png", NULL);
	clutter_actor_set_size (cage, 64, 64);
	clutter_container_add_actor (CLUTTER_CONTAINER (stage), cage);
	clutter_actor_set_position (cage, 9*64, 7*64);		

	int i;
	for(i=0;i<MAX_MUSHROOMS;i++)
	{
		mushroom[i] = clutter_texture_new_from_file("mushroom.png", NULL);
		clutter_actor_set_size (mushroom[i], 64, 64);
		clutter_container_add_actor (CLUTTER_CONTAINER (stage), mushroom[i]);
		clutter_actor_set_position (mushroom[i], (rand()%9)*64, (rand()%7)*64);		
		clutter_actor_set_opacity(mushroom[i], 0x00);
	}

	for(i=0;i<MAX_WAGNERS;i++)
	{
		wagner[i] = clutter_texture_new_from_file("wagner.png", NULL);
		clutter_actor_set_size (wagner[i], 64, 64);
		clutter_container_add_actor (CLUTTER_CONTAINER (stage), wagner[i]);
		clutter_actor_set_position (wagner[i], (rand()%8)*64, (rand()%6)*64);		
		clutter_actor_set_opacity(wagner[i], 0x00);
	}

	char text[64];
	sprintf(text, "MUSHROOMS: %d/%d", mushrooms_collected, MAX_MUSHROOMS);
	score = clutter_text_new_full("Serif Bold 12", text, &white);
	clutter_actor_set_size(score, 320, 240);
	clutter_actor_set_position(score, 10, 10);
	clutter_container_add_actor(CLUTTER_CONTAINER(stage), score);
	clutter_actor_set_opacity(score, 0x00);

	gameOver = clutter_text_new_full("Serif 140", "GAME OVER!", &red);
	clutter_actor_set_size(gameOver, 640, 480);
	clutter_actor_set_position(gameOver, 0, 0);
	clutter_container_add_actor(CLUTTER_CONTAINER(stage), gameOver);
	clutter_actor_set_opacity(gameOver, 0x00);

	youWin = clutter_text_new_full("Serif 160", "YOU WIN!", &cream);
	clutter_actor_set_size(youWin, 640, 480);
	clutter_actor_set_position(youWin, 0, 0);
	clutter_container_add_actor(CLUTTER_CONTAINER(stage), youWin);
	clutter_actor_set_opacity(youWin, 0x00);

	restartGroup = clutter_group_new();
	clutter_actor_set_position(restartGroup, 500, 460);
	clutter_actor_set_size(restartGroup, 100, 30);
	clutter_container_add_actor(CLUTTER_CONTAINER(stage), restartGroup);
	clutter_actor_set_reactive (restartGroup, TRUE);
	
	restartBg = clutter_rectangle_new_with_color(&orange);
	clutter_container_add_actor(CLUTTER_CONTAINER(restartGroup), restartBg);
	clutter_actor_set_size(restartBg, 100, 30);
        clutter_actor_set_position(restartBg, 0, 0);

	restartButton = clutter_text_new_full("Sans 12", "Try Again", &cream);
	clutter_container_add_actor(CLUTTER_CONTAINER(restartGroup), restartButton);
	clutter_actor_set_size(restartButton, 100, 30);
        clutter_actor_set_position(restartButton, 10, 5);
	clutter_actor_set_opacity(restartGroup, 0x00);
	
	clutter_actor_show(restartGroup);

	clutter_actor_show (stage);

	g_signal_connect (restartGroup, "button-press-event", G_CALLBACK (on_restartGroup_click), NULL);
	g_signal_connect (mainOk, "button-press-event", G_CALLBACK (on_mainOk_click), NULL);
	g_signal_connect (stage, "key-press-event", G_CALLBACK (on_key_press), NULL);

	clutter_main ();
	
	return 0;
}
